

import bpy,sys,os,imp,random

from bpy.props import *
from mathutils import Matrix,Vector,Euler,Quaternion
from ctypes import*
from bpy_extras import object_utils
import bmesh
from math import*


#/////////////////////////////////////////
PIΞ2=1.5707963267948966;
PI2=6.283185307179586;


#/////////////////////////////////////////
global iG;iG=0;#global Ds名o物G;Ds名o物G={};

#--------数学公式---------------------------------------------------------
def  atan3(x, y):#出360度内正弧度
    z=pow(x,2)+pow(y,2);
    if(z==0):
        return 0;
        #z==0.00001;

    if(y>=0 ):#在↑
        return acos(x/sqrt(z));
    else:#(y<0and x<=0)#在↙
        #print("y<=0\n");
        c=acos(x/sqrt(z));
        return c+(pi-c)*2;

def f2巜f2十f2(f2一,  f2二):   return [f2一[0]+f2二[0],f2一[1]+f2二[1]];
def f2十f2_f2(f2一,  f2二,f2三):  f2三[0]=f2一[0]+f2二[0];f2三[1]=f2一[1]+f2二[1];
def f3巜f3十f3(f3一,  f3二):   return [f3一[0]+f3二[0],f3一[1]+f3二[1],f3一[2]+f3二[2]];
def v巜f3十f3(f3一,  f3二):   return Vector((f3一[0]+f3二[0],f3一[1]+f3二[1],f3一[2]+f3二[2]));

def f3十f3_f3(f3一,  f3二,f3三):   f3三[0]=f3一[0]+f3二[0];f3三[1]=f3一[1]+f3二[1];f3三[2]=f3一[2]+f3二[2];
def f3十f3_(f3一,  f3二):   f3二[0]=f3一[0]+f3二[0];f3二[1]=f3一[1]+f3二[1];f3二[2]=f3一[2]+f3二[2];
def f2巜f2十f2Ξ2(f2一,  f2二):  return  [(f2一[0]+f2二[0])/2,(f2一[1]+f2二[1])/2];
def f3巜f3十f3Ξ2(f3一,  f3二):   return  [(f3一[0]+f3二[0])/2,(f3一[1]+f3二[1])/2,(f3一[2]+f3二[2])/2];

def f2巜f2一f2(f2一,  f2二):   return [f2一[0]-f2二[0],f2一[1]-f2二[1]];
def f3巜f3一f3(f3一,  f3二):   return [f3一[0]-f3二[0],f3一[1]-f3二[1],f3一[2]-f3二[2]];
def v巜f3一f3(f3一,  f3二):   return Vector((f3一[0]-f3二[0],f3一[1]-f3二[1],f3一[2]-f3二[2]));


def f2一f2_f2(f2一,  f2二,f2三):f2三[0]=f2一[0]-f2二[0];f2三[1]=f2一[1]-f2二[1];

def f3一f3_f3(f3一,  f3二,  f3三): f3三[0]=f3一[0]-f3二[0];f3三[1]=f3一[1]-f3二[1];f3三[2]=f3一[2]-f3二[2];

def f2Χf_f2(f2一,  f,  f2三): f2三[0]=f2一[0]*f;f2三[1]=f2一[1]*f;
def f3Χf_f3(f3一,  f,  f2三): f2三[0]=f3一[0]*f;f2三[1]=f3一[1]*f;f2三[2]=f3一[2]*f;
def f3巜f3Χf(f3一,  f): return [f3一[0]*f,f3一[1]*f,f3一[2]*f];

def f巜f3λf3(f3点X, f3点Y):
    print("----",f3点X[0]* f3点Y[0],f3点X[1]* f3点Y[1],f3点X[2]* f3点Y[2]);
    print("--",f3点X[2],f3点Y[2]);
    return f3点X[0]* f3点Y[0]+f3点X[1]* f3点Y[1]+f3点X[2]* f3点Y[2];
def f巜f3Γf3(f3点X, f3点Y): # 两乛 的垂线乛  #等同 f3点X.cross(f3点Y)
    return (f3点X[1]*f3点Y[2]-f3点X[2]*f3点Y[1]  ,  f3点X[2]*f3点Y[0]-f3点X[0]*f3点Y[2]  ,  f3点X[0]*f3点Y[1]-f3点X[1]*f3点Y[0]);
    
def f3Γf3_f3(f3点X, f3点Y,f3点Z_):
    #print("F",f3点X, f3点Y,f3点Z_);
    f3点Z_[0]=f3点X[1]*f3点Y[2]-f3点X[2]*f3点Y[1];  
    f3点Z_[1]=f3点X[2]*f3点Y[0]-f3点X[0]*f3点Y[2]; 
    f3点Z_[2]=f3点X[0]*f3点Y[1]-f3点X[1]*f3点Y[0];
    
def f巜vΓv(f3点X, f3点Y): # 两乛 的垂线乛  #等同 f3点X.cross(f3点Y)
    return Vector((f3点X[1]*f3点Y[2]-f3点X[2]*f3点Y[1]  ,  f3点X[2]*f3点Y[0]-f3点X[0]*f3点Y[2]  ,  f3点X[0]*f3点Y[1]-f3点X[1]*f3点Y[0]));

    
def f巜f2乛f2(f2一,  f2二):
    f2三=[None,None];f2三[0]=f2一[0]-f2二[0];f2三[1]=f2一[1]-f2二[1];
    fUV距离=sqrt(pow(f2三[0],2)+pow(f2三[1],2));
    return fUV距离;
    
def 冖1(f3长):
    f对角线长=sqrt(pow(f3长[0],2)+pow(f3长[1],2)+pow(f3长[2],2));
    return f对角线长;
 
def tSum(f3):
    艹=0;
    for t in f3:
        艹+=t;
    return 艹;
    
def 冖(f3一,  f3二):
    f3长=[None,None,None];f3长[0]=f3一[0]-f3二[0];f3长[1]=f3一[1]-f3二[1];f3长[2]=f3一[2]-f3二[2];
    return sqrt(pow(f3长[0],2)+pow(f3长[1],2)+pow(f3长[2],2));

    
def 冖f2(f3一,  f3二):
    f3长=[None,None];f3长[0]=f3一[0]-f3二[0];f3长[1]=f3一[1]-f3二[1];
    return sqrt(pow(f3长[0],2)+pow(f3长[1],2));

    
#========================================
def ClampMin(min,R):  
    if(R<min):return min;#//R不能 < min //<<<
def ClampMax(max,R):  
    if(R>max):return max;#//R不能 > max//>>>
def ClampMinMax(min,max,R):
    if(R>max):return max;
    elif(R<min):return min;
    
def Min(f3):
    f最小=10000000;
    for i in range(3):
        f=f3[i];
        if(f<f最小):#>>>>
            f最小=f;
    return f最小;
    
def Max(f3):
    f最大=-10000000;
    for i in range(3):
        f=f3[i];
        if(f>f最大):#< < < 
            f最大=f;
    return f最大;
      
def iΞf (i,  f):
    iΞ=i/f;
    f小数=iΞ-int(iΞ);
    if(f小数>0.5):I+=1;
    return I;

#====万能加减===================================================
def TΔΔ减G(T1,T2):
    T结果=[];#print("--Type==",type(T1),type(T2));
    if(str(type(T1)) in["<class 'int'>","<class 'float'>","<class 'IntProperty'>","<class 'FloatProperty'>"]):
        if(str(type(T2)) in["<class 'int'>","<class 'float'>","<class 'IntProperty'>","<class 'FloatProperty'>"]):
            T结果=T1-T2;
        elif(str(type(T2)) in["<class 'list'>","<class 'tuple'>","<class 'IDPropertyArray'>","<class 'Vector'>","<class 'Euler'>"]):
            for i in range(len(T2)):
                T结果.append(T1-T2[i]);


    elif(str(type(T1)) in["<class 'list'>","<class 'tuple'>","<class 'IDPropertyArray'>","<class 'Vector'>","<class 'Euler'>"]):
        if(str(type(T2)) in["<class 'list'>","<class 'tuple'>","<class 'IDPropertyArray'>","<class 'Vector'>","<class 'Euler'>"]):
            for i in range(len(T2)):
                T结果.append(T1[i]-T2[i]);
        elif(str(type(T2)) in["<class 'int'>","<class 'float'>","<class 'IntProperty'>","<class 'FloatProperty'>"]):
            for i in range(len(T1)):
                T结果.append(T1[i]-T2);

    elif(str(type(T1)) in["<class 'bool'>","<class 'string'>"] and str(type(T2)) in["<class 'bool'>","<class 'string'>"]):
        return T2;

    return T结果;

#------------------------------------------------------------
def TΔΔ加G(T1,T2):
    T结果=[];#print("++Type==",type(T1),type(T2));//"<class 'dict'>"
    if(str(type(T1)) in["<class 'int'>","<class 'float'>","<class 'IntProperty'>","<class 'FloatProperty'>"]):
        if(str(type(T2)) in["<class 'int'>","<class 'float'>","<class 'IntProperty'>","<class 'FloatProperty'>"]):
            T结果=T1+T2;
        elif(str(type(T2)) in["<class 'list'>","<class 'tuple'>","<class 'IDPropertyArray'>","<class 'Vector'>","<class 'Euler'>"]):
            for i in range(len(T2)):
                T结果.append(T1+T2[i]);


    elif(str(type(T1)) in["<class 'list'>","<class 'tuple'>","<class 'IDPropertyArray'>","<class 'Vector'>","<class 'Euler'>"]):
        if(str(type(T2)) in["<class 'list'>","<class 'tuple'>","<class 'IDPropertyArray'>","<class 'Vector'>","<class 'Euler'>"]):
            for i in range(len(T2)):
                T结果.append(T1[i]+T2[i]);
        elif(str(type(T2)) in["<class 'int'>","<class 'float'>","<class 'IntProperty'>","<class 'FloatProperty'>"]):
            for i in range(len(T1)):
                T结果.append(T1[i]+T2);

    elif(str(type(T1)) in["<class 'bool'>","<class 'string'>"] and str(type(T2)) in["<class 'bool'>","<class 'string'>"]):
        return T2;

    return T结果;

#------------------------------------------------------------
def TΔΔ乘G(T1,T2):
    T结果=[];#print("**Type==",type(T1),type(T2));
    if(str(type(T1)) in["<class 'int'>","<class 'float'>","<class 'IntProperty'>","<class 'FloatProperty'>"]):
        if(str(type(T2)) in["<class 'int'>","<class 'float'>","<class 'IntProperty'>","<class 'FloatProperty'>"]):
            T结果=T1*T2;
        elif(str(type(T2)) in["<class 'list'>","<class 'tuple'>","<class 'IDPropertyArray'>","<class 'Vector'>","<class 'Euler'>"]):
            for i in range(len(T2)):
                T结果.append(T1*T2[i]);


    elif(str(type(T1)) in["<class 'list'>","<class 'tuple'>","<class 'IDPropertyArray'>","<class 'Vector'>","<class 'Euler'>"]):
        if(str(type(T2)) in["<class 'list'>","<class 'tuple'>","<class 'IDPropertyArray'>","<class 'Vector'>","<class 'Euler'>"]):
            for i in range(len(T2)):
                T结果.append(T1[i]*T2[i]);
        elif(str(type(T2)) in["<class 'int'>","<class 'float'>","<class 'IntProperty'>","<class 'FloatProperty'>"]):
            for i in range(len(T1)):
                T结果.append(T1[i]*T2);
    elif(str(type(T1)) in["<class 'bool'>","<class 'string'>"] and str(type(T2)) in["<class 'bool'>","<class 'string'>"]):
        return T2;

    return T结果;

#------------------------------------------------------------
def TΔΔ除G(T1,T2):
    T结果=[];
    if(str(type(T1)) in["<class 'int'>","<class 'float'>","<class 'IntProperty'>","<class 'FloatProperty'>"]):
        if(str(type(T2)) in["<class 'int'>","<class 'float'>","<class 'IntProperty'>","<class 'FloatProperty'>"]):
            T结果=T1/T2;
        elif(str(type(T2)) in["<class 'list'>","<class 'tuple'>","<class 'IDPropertyArray'>","<class 'Vector'>","<class 'Euler'>"]):
            for i in range(len(T2)):
                T结果.append(T1/T2[i]);


    elif(str(type(T1)) in["<class 'list'>","<class 'tuple'>","<class 'IDPropertyArray'>","<class 'Vector'>","<class 'Euler'>"]):
        if(str(type(T2)) in["<class 'list'>","<class 'tuple'>","<class 'IDPropertyArray'>","<class 'Vector'>","<class 'Euler'>"]):
            for i in range(len(T2)):
                T结果.append(T1[i]/T2[i]);
        elif(str(type(T2)) in["<class 'int'>","<class 'float'>","<class 'IntProperty'>","<class 'FloatProperty'>"]):
            for i in range(len(T1)):
                T结果.append(T1[i]/T2);

    elif(str(type(T1)) in["<class 'bool'>","<class 'string'>"] and str(type(T2)) in["<class 'bool'>","<class 'string'>"]):
        return T2;

    return T结果;

#==============================================================
def fΔΔ两f2夹角弧正G(f2点一, f2点二):#这个夹角是小于180度
    # f2圆心=0.0f,0.0f; f2头
    f对弧一=atan3(f2点一[0],f2点一[1]);#  Y#X
    f对弧二=atan3(f2点二[0],f2点二[1]);
    return abs(f对弧二-f对弧一);

def ΛRadians(f3点一, f3点二):#这个夹角是小于180度 正
    #double c, d;
    c = f3点一[0]*f3点二[0] + f3点一[1]*f3点二[1] + f3点一[2]*f3点二[2];#点积
    d = sqrt(f3点一[0]*f3点一[0] + f3点一[1]*f3点一[1] + f3点一[2]*f3点一[2]) * sqrt(f3点二[0]*f3点二[0] + f3点二[1]*f3点二[1] + f3点二[2]*f3点二[2]);#这两个乛长相乘
    if(d==0):d=0.0001;
    #print("ACOS==",acos(c/d));
    return acos(c/d);

def ΛmRadians(m一, m二,s轴):
    if(s轴=="X"):
        v一=m一[0][0],m一[1][0],m一[2][0];
        v二=m二[0][0],m二[1][0],m二[2][0];
    elif(s轴=="Y"):
        v一=m一[0][1],m一[1][1],m一[2][1];
        v二=m二[0][1],m二[1][1],m二[2][1];
    elif(s轴=="Z"):
        v一=m一[0][2],m一[1][2],m一[2][2];
        v二=m二[0][2],m二[1][2],m二[2][2];
    return ΛRadians(v一, v二);


def ΔΔ角对边乛G(f2邻边乛, f2斜边乛, f2对边乛):#得对边的乛
    f夹角弧=fΔΔ两f2夹角弧正G(f2邻边乛,f2斜边乛);
    f邻边长=sqrt(pow(f2邻边乛[0],2)+pow(f2邻边乛[1],2));
    f斜边长=sqrt(pow(f2斜边乛[0],2)+pow(f2斜边乛[1],2));
    f对边长=f斜边长*cos(f夹角弧);
    f邻边比例=f对边长/f邻边长;
    f2对边乛[0]=f2邻边乛[0]*f邻边比例;f2对边乛[1]=f2邻边乛[1]*f邻边比例;

def f3ΔΔ角对边乛G(f3邻边乛, f3斜边乛):#得对边的乛
    f3对边乛=[None,None,None];
    f夹角弧=ΛRadians(f3邻边乛,f3斜边乛);
    f邻边长=sqrt(pow(f3邻边乛[0],2)+pow(f3邻边乛[1],2)+pow(f3邻边乛[2],2));
    f斜边长=sqrt(pow(f3斜边乛[0],2)+pow(f3斜边乛[1],2)+pow(f3斜边乛[2],2));
    f对边长=f斜边长*cos(f夹角弧);
    f邻边比例=f对边长/f邻边长;
    f3对边乛[0]=f3邻边乛[0]*f邻边比例;f3对边乛[1]=f3邻边乛[1]*f邻边比例;f3对边乛[2]=f3邻边乛[2]*f邻边比例;

    #memcpy(f2对边乛,Lf2uv选序[i序真],sizeof(f2对边乛));


#//////////////////////////////////////////
def radiansF3(f3角度):
    f3弧度=3*[None];
    f3弧度[0]=radians(f3角度[0]);f3弧度[1]=radians(f3角度[1]);f3弧度[2]=radians(f3角度[2]);
    return f3弧度;
    
def radiansF3_(f3角度):
    f3角度[0]=radians(f3角度[0]);f3角度[1]=radians(f3角度[1]);f3角度[2]=radians(f3角度[2]);
    #print("2 f3角度==",*f3角度);
    
def degreesF3(f3弧度):
    f3角度=3*[None];
    f3角度[0]=degrees(f3弧度[0]);f3角度[1]=degrees(f3弧度[1]);f3角度[2]=degrees(f3弧度[2]);
    return f3角度;
    
def degreesF3_(f3弧度):
    f3弧度[0]=degrees(f3弧度[0]);f3弧度[1]=degrees(f3弧度[1]);f3弧度[2]=degrees(f3弧度[2]);    
#////几何////////////////////////////////////////
#☐☐☐☐☐●f3高☐☐☐☐
#☐☐☐☐┆\☐☐☐☐☐
#☐☐☐☐│☐┊\☐☐☐☐
#☐☐☐┆☐☐●☐\☐☐☐
#☐☐☐│☐☐☐┊☐\☐☐
#☐☐┆☐☐☐☐┇☐☐\
#☐☐●━━━━●━━→●
#☐f3底1 ☐☐f3中点底        f3底2
def vΔΔ三角形中心G(f3底1,f3底2,f3高):
    return Vector(((f3底1[0]+f3底2[0]+f3高[0])/3,(f3底1[1]+f3底2[1]+f3高[1])/3,(f3底1[2]+f3底2[2]+f3高[2])/3));

def vΔΔ修正垂线G(v乛X,v乛共丄Z):
    #f点积=v乛共丄Z.dot(v乛X);
    #f点积=f巜f3λf3(v乛共丄Z,v乛X);
    f夹角=ΛRadians(v乛共丄Z,v乛X);
    print("WRONG==",v乛共丄Z);
    print("ANGLE==",f夹角);
    if(f夹角<1.5706 or f夹角>1.5708):#不垂直

        #f夹角=ΛRadians(v乛X,v乛共丄Z);
        f共丄长=v乛共丄Z.length;fX长=v乛X.length;
        f邻边长=f共丄长*cos(f夹角);
        f邻边ΞX=f邻边长/fX长;
        v乛邻边=v乛X*f邻边ΞX;#可以是十一方向
        v乛修十共丄Z=v乛共丄Z-v乛邻边;#修十
        print("CORRECT==",v乛修十共丄Z);

        return v乛修十共丄Z;
    return None;
    #☐☐☐☐v乛修十共丄Z☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #v乛共丄Z☐ ☐  ↑☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐☐☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐↑┊☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐┃┇☐☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐┃☐┊☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐┃☐┇☐┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐┃☐☐┊┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐   cos ( ┇┃☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐☐
    #☐☐←━━━╋━━━━━━━→v乛X☐☐☐☐☐☐☐
    #☐v乛邻边


#/////////////////////////////////////////
def fΔΔ从f2一逆到f2二弧十(f2点一, f2点二):#这个角可以大于180度
    f对弧一=atan3(f2点一[0],f2点一[1]);#  Y#X
    f对弧二=atan3(f2点二[0],f2点二[1]);
    if(f对弧一<f对弧二):
        return f对弧二-f对弧一;
    elif(f对弧一>f对弧二):
        return 360-(f对弧一-f对弧二);
    elif(f对弧一==f对弧二):
        return 0.0;

def f2ΔΔ从乛一逆弧后的乛(f2点一, f逆弧度):#这个角可以大于180度
    f弧一=atan3(f2点一[0],f2点一[1]);#  Y#X
    f最终弧=(f弧一+f逆弧度)%piΧ2;
    f线长=sqrt(pow(f2点一[0],2)+pow(f2点一[1],2));

    f2结果=[None,None];
    f2结果[0]=f线长*cos(f最终弧);f2结果[1]=f线长*sin(f最终弧);
    return f2结果;
    
#////CTYPES/////////////////////////////////////////
def ΔΔcf33一反m二G(cf33,m):
    m[0][0]=cf33[0][0];m[0][1]=cf33[1][0];m[0][2]=cf33[2][0];m[0][3]=0;
    m[1][0]=cf33[0][1];m[1][1]=cf33[1][1];m[1][2]=cf33[2][1];m[1][3]=0;
    m[2][0]=cf33[0][1];m[2][1]=cf33[1][2];m[2][2]=cf33[2][2];m[2][3]=0;
    m[3][0]=0;m[3][1]=0;m[3][2]=0;m[3][3]=1;
def ΔΔcf44一反m二G(cf33,m):
    m[0][0]=cf33[0][0];m[0][1]=cf33[1][0];m[0][2]=cf33[2][0];m[0][3]=cf33[3][0];
    m[1][0]=cf33[0][1];m[1][1]=cf33[1][1];m[1][2]=cf33[2][1];m[1][3]=cf33[3][1];
    m[2][0]=cf33[0][1];m[2][1]=cf33[1][2];m[2][2]=cf33[2][2];m[2][3]=cf33[3][2];
    m[3][0]=cf33[0][3];m[3][1]=cf33[1][3];m[3][2]=cf33[2][3];m[3][3]=cf33[3][3];
def ΔΔcf44一反f44二G(cf33,m):
    m[0][0]=cf33[0][0];m[0][1]=cf33[1][0];m[0][2]=cf33[2][0];m[0][3]=cf33[3][0];
    m[1][0]=cf33[0][1];m[1][1]=cf33[1][1];m[1][2]=cf33[2][1];m[1][3]=cf33[3][1];
    m[2][0]=cf33[0][1];m[2][1]=cf33[1][2];m[2][2]=cf33[2][2];m[2][3]=cf33[3][2];
    m[3][0]=cf33[0][3];m[3][1]=cf33[1][3];m[3][2]=cf33[2][3];m[3][3]=cf33[3][3];
    


#/////////////////////////////////////////
def mΔΔ保存相对于总父的子本地矩阵(o总父,o子,o孙):
    if(o子.type=="CURVE"):#子丅 是相对于CURVE 的第1个点丅
        if(o子.data.use_path):
            sp=o子.data.splines[0];
            if(sp.type=="BEZIER"):
                v4第一点丅L=sp.bezier_points[0].co;#这个是v4
            else:
                v4第一点丅L=sp.points[0].co;#这个是v4

            v4第一点丅负L=Vector((-v4第一点丅L[0],-v4第一点丅L[1],-v4第一点丅L[2]));
            v4第一点丅负=o子.matrix_world*v4第一点丅负L-o子.location;#是相对o子方向 的全局点丅所以要  -o子.location

            m孙=o孙.matrix_world;m孙丅全局应=m孙.copy();
            m孙丅全局应[0][3],m孙丅全局应[1][3],m孙丅全局应[2][3]=m孙[0][3]+v4第一点丅负.x,m孙[1][3]+v4第一点丅负.y,m孙[2][3]+v4第一点丅负.z;#加上第一点的全局丅
            m孙相对o总父L=(o总父.matrix_world.inverted())*m孙丅全局应#*m孙缩放;#这个是相对总父的本地矩阵
            #print("M L==",m孙相对o总父L[0][3],m孙相对o总父L[1][3],m孙相对o总父L[2][3]);

        else:
            m孙相对o总父L=(o总父.matrix_world.inverted())*o孙.matrix_world;
    #------------------------------------------------------------
    else:
        m孙相对o总父L=(o总父.matrix_world.inverted())*o孙.matrix_world;#这个是相对总父的本地矩阵

    return m孙相对o总父L;

def rotate(f3原,f3轴,ㄥ旋角):
    #return (f3原*cos(ㄥ旋角)  +  f3轴.cross(f3原)*sin(ㄥ旋角)  +  f3轴*(1-cos(ㄥ旋角))*(f3原.dot(f3轴)) ;
    return f3巜f3Χf(f3原,cos(ㄥ旋角))  +  f巜f3Γf3(f3轴,f3原)*sin(ㄥ旋角)  + f3巜f3Χf( f3巜f3Χf(f3轴,(1-cos(ㄥ旋角))),f巜f3Γf3(f3原,f3轴));


def rotateV(v原,v轴,ㄥ旋角):
    #v__=[None,None,None];
    return  v原*cos(ㄥ旋角)  +  v轴.cross(v原)*sin(ㄥ旋角)  +  v轴*(1-cos(ㄥ旋角))*(v原.dot(v轴)) ;
    

#///////////////////////////////////////////
def L4位小数(Lf):
    if(str(type(Lf)) in["<class 'float'>"]):
        return round(Lf,4);
    elif(str(type(Lf)) in["<class 'int'>","<class 'string'>","<class 'bool'>"]):
        return Lf;

    #----列表浮点---------------------------------------------------------------
    L2=[];Lf=list(Lf);
    for i,f in enumerate(Lf):
        if(f==1):
            f=1.000;
        L2.append(round(f,4));
    return L2;
    
#///////////////////////////////////////////
def L几位小数(Lf,i小数丅):
    if(str(type(Lf)) in["<class 'float'>"]):
        return round(Lf,i小数丅);
    elif(str(type(Lf)) in["<class 'int'>","<class 'string'>","<class 'bool'>"]):
        return Lf;

    #----浮点列表---------------------------------------------------------------
    L2=[];Lf=list(Lf);#这个会去掉欧拉的"XYZ" 只保留前三个
    for i,f in enumerate(Lf):
        if(f==1.0):
            f=1.000;
        L2.append(round(f,i小数丅));
    return L2;

#////几何///////////////////////////////////////
def  iΔ圆心与半径G(f2头,f2尾,f2间,f3XYR):
    k1=k2=0;
    x1=(f2头[0]);y1=(f2头[1]);x2=(f2尾[0]);y2=(f2尾[1]);x3=(f2间[0]);y3=(f2间[1]);
    print("x1",x1,"y1",y1,"x2",x2,"y2",y2,"x3",x3,"y3",y3,)
    if((y1==y2) and (y2==y3)):
        print("NO\n");
        return  False ;

    elif((y1!=y2)and(y2!=y3)):
        k1=(x2-x1)/(y2-y1);
        k2=(x3-x2)/(y3-y2);
        print("k1=%f  k2=%f\n",k1,k2);

        if((0<=abs(k1-k2)) and (abs(k1-k2)<0.002)) :

            print("NO 2\n");
            #ΔΔ平均拉直()
            return False  ;

    a=(2*(x2-x1));
    b=(2*(y2-y1));
    #print("a=%d\n",a,"b=%d\n",b);
    c=(x2*x2+y2*y2-x1*x1-y1*y1);
    d=(2*(x3-x2));
    e=(2*(y3-y2));
    f=(x3*x3+y3*y3-x2*x2-y2*y2);

    x=(b*f-e*c)/(b*d-e*a);
    y=(d*c-a*f)/(b*d-e*a);

    #print("圆心x为%d\n", x, "圆心y为%d\n",y);
    r=sqrt((x-x1)*(x-x1)+(y-y1)*(y-y1));
    #print("半径为%d\n", r);
    f3XYR[0]=x;f3XYR[1]=y;f3XYR[2]=r;
    # return  f3XYR;
    return True ;
    
    
    
#///end////end////end////end////end////end////end////end////end////



